/*******************************************************************************
 * FoxGearHudWidget generated by Eliot.UELib using UE Explorer.
 * Eliot.UELib ? 2009-2015 Eliot van Uytfanghe. All rights reserved.
 * http://eliotvu.com
 *
 * All rights belong to their respective owners.
 *******************************************************************************/
class FoxGearHudWidget extends GFxObject within GFxMoviePlayer;

struct native HudGearInfo
{
    var string sGearKey;
    var string sGearIcon;
    var string sDefaultKey;
    var bool bIsDeployed;
    var bool bIsUsed;
    var string sGearName;

    structdefaultproperties
    {
        sGearKey=""
        sGearIcon=""
        sDefaultKey=""
        bIsDeployed=false
        bIsUsed=false
        sGearName=""
    }
};

var FoxPC PCOwner;

function UpdateGear()
{
    local int I, ActiveGearCount, InActiveGearCount, KeyIndex, MaxGearCount;

    local HudGearInfo GearInfo;
    local byte DataProviderIndex;
    local ProfileGearInfo LoadoutGearInfo;
    local FoxDataProvider_Gear_Attachment DataProvider;
    local FoxWeapon Weapon;
    local FoxInventoryManager InvManager;
    local FoxPawn ForPawn;
    local bool bFPSpectator;
    local string GearSelectCommands[4], BindKey;

    // End:0x4F
    if(PCOwner.MyFoxPawn != none)
    {
        ForPawn = PCOwner.MyFoxPawn;
    }
    // End:0xAE
    else
    {
        // End:0xAE
        if(PCOwner.IsFPSpectating())
        {
            bFPSpectator = true;
            ForPawn = FoxPawn(PCOwner.ViewTarget);
        }
    }
    // End:0xF8
    if(FoxVehicle(ForPawn) != none)
    {
        ForPawn = FoxVehicle(ForPawn).GetDriver();
    }
    // End:0x109
    if(ForPawn == none)
    {
        return;
    }
    // End:0x174
    if(class'FoxLoadoutInfo'.static.IsGearValid(ForPawn.GearInfo))
    {
        LoadoutGearInfo = ForPawn.GearInfo;
    }
    // End:0x1D0
    else
    {
        LoadoutGearInfo = FoxPRI(ForPawn.PlayerReplicationInfo).Loadout.GetCurrentGearInfo();
    }
    ActiveGearCount = 0;
    InActiveGearCount = 1;
    InvManager = FoxInventoryManager(ForPawn.InvManager);
    MaxGearCount = 0;
    MaxGearCount += ((ValidGearIndex(LoadoutGearInfo.Gear_R1ID)) ? 1 : 0);
    MaxGearCount += ((ValidGearIndex(LoadoutGearInfo.Gear_L1ID)) ? 1 : 0);
    MaxGearCount += ((ValidGearIndex(LoadoutGearInfo.Gear_R2ID)) ? 1 : 0);
    MaxGearCount += ((ValidGearIndex(LoadoutGearInfo.Gear_L2ID)) ? 1 : 0);
    I = 0;
    J0x30D:
    // End:0x35F [Loop If]
    if(I < 4)
    {
        GearSelectCommands[I] = "GBA_SelectGear" $ string(I + 1);
        ++ I;
        // [Loop Continue]
        goto J0x30D;
    }
    I = 0;
    J0x36A:
    // End:0xA51 [Loop If]
    if(I < 4)
    {
        switch(I)
        {
            // End:0x3BA
            case 0:
                DataProviderIndex = LoadoutGearInfo.Gear_R1ID;
                // End:0x446
                break;
            // End:0x3E7
            case 1:
                DataProviderIndex = LoadoutGearInfo.Gear_L1ID;
                // End:0x446
                break;
            // End:0x415
            case 2:
                DataProviderIndex = LoadoutGearInfo.Gear_R2ID;
                // End:0x446
                break;
            // End:0x443
            case 3:
                DataProviderIndex = LoadoutGearInfo.Gear_L2ID;
                // End:0x446
                break;
            // End:0xFFFF
            default:
                // End:0xA43
                if(ValidGearIndex(DataProviderIndex))
                {
                    DataProvider = FoxDataProvider_Gear_Attachment(PCOwner.DynamicUI.UnlockablesDataStore.AttachmentProviderArray[DataProviderIndex]);
                    GearInfo.sGearName = DataProvider.FriendlyName;
                    GearInfo.sGearIcon = class'ZeMovieBase'.static.MarkupImageString(DataProvider.ImageIconRef);
                    // End:0x5FC
                    if((DataProviderIndex != 0) && DataProvider.WeaponClassName != "")
                    {
                        KeyIndex = ActiveGearCount;
                        ++ ActiveGearCount;
                        Weapon = ((InvManager != none) ? InvManager.GetWeaponFromIndex(KeyIndex + 2) : none);
                    }
                    // End:0x630
                    else
                    {
                        KeyIndex = MaxGearCount - InActiveGearCount;
                        ++ InActiveGearCount;
                        Weapon = none;
                    }
                    GearInfo.bIsDeployed = ((Weapon != none) && FoxWeapon_MineBase(Weapon) != none) && PCOwner.MyFoxHud.IsMineDeployedForWeapon(Weapon);
                    GearInfo.bIsUsed = ((Weapon != none) && !Weapon.HasAnyAmmo()) && !GearInfo.bIsDeployed;
                    // End:0x8FC
                    if((DataProvider.WeaponClassName != "") && !bFPSpectator)
                    {
                        // End:0x874
                        if(PCOwner.MyFoxInput.bUsingGamepad || class'WorldInfo'.static.IsConsoleBuild())
                        {
                            BindKey = PCOwner.MyFoxInput.GetBindNameFromCommand(GearSelectCommands[KeyIndex], true);
                            GearInfo.sGearKey = PCOwner.DynamicUI.MarkupImageStringFromControllerButtonName(BindKey, 16, 16, -4);
                        }
                        // End:0x8F9
                        else
                        {
                            GearInfo.sGearKey = ("[" $ class'FoxUI'.static.GetBindingKeyLocalizedString(string(PCOwner.MyFoxInput.GearSelectKeyNames[KeyIndex]))) $ "]";
                        }
                    }
                    // End:0x91B
                    else
                    {
                        GearInfo.sGearKey = "";
                    }
                    GearInfo.sDefaultKey = "";
                    // End:0xA27
                    if((((InvManager != none) && InvManager.QuickSelectGearIndex == KeyIndex) && !GearInfo.bIsUsed) && !bFPSpectator)
                    {
                        GearInfo.sDefaultKey = ("[" $ class'FoxUI'.static.GetBindingKeyLocalizedString(string(PCOwner.MyFoxInput.QuickGearSelectKeyName))) $ "]";
                    }
                    as_UpdateGearItem(KeyIndex, GearInfo);
                }
                ++ I;
                // [Loop Continue]
                goto J0x36A;
            }
            GearInfo.sGearKey = "";
            GearInfo.sGearName = "";
            GearInfo.sGearIcon = "";
            I = MaxGearCount;
            J0xAC1:
            // End:0xAFB [Loop If]
            if(I < 4)
            {
                as_UpdateGearItem(I, GearInfo);
                ++ I;
                // [Loop Continue]
                goto J0xAC1;
            }
            // End:0xB65
            if((InvManager != none) && InvManager.SelectedInventoryIndex > 1)
            {
                as_SetGearSelected(InvManager.SelectedInventoryIndex - 2);
            }
            //return;            
}

function bool ValidGearIndex(byte GearIndex)
{
    return (GearIndex > 0) && GearIndex < PCOwner.DynamicUI.UnlockablesDataStore.AttachmentProviderArray.Length;
    //return ReturnValue;    
}

function OnNewWeaponSelected(FoxWeapon NewWeapon)
{
    local int InventoryIndex;
    local FoxPawn ForPawn;

    UpdateGear();
    // End:0xAB
    if((((NewWeapon == none) || NewWeapon.WeaponType == 0) || NewWeapon.WeaponType == 1) || NewWeapon.WeaponType == 5)
    {
        as_SetGearSelected(-1);
        return;
    }
    // End:0xFA
    if(PCOwner.MyFoxPawn != none)
    {
        ForPawn = PCOwner.MyFoxPawn;
    }
    // End:0x14D
    else
    {
        // End:0x14D
        if(PCOwner.IsFPSpectating())
        {
            ForPawn = FoxPawn(PCOwner.ViewTarget);
        }
    }
    // End:0x184
    if((ForPawn == none) || ForPawn.InvManager == none)
    {
        return;
    }
    InventoryIndex = FoxInventoryManager(ForPawn.InvManager).GetIndexFromWeapon(NewWeapon);
    InventoryIndex -= 2;
    as_SetGearSelected(InventoryIndex);
    //return;    
}

function NotifyMineDestroyed(FoxProjectile_MineBase Mine)
{
    local FoxInventoryManager InvManager;
    local FoxWeapon OwningWeapon, CurrWeapon;
    local int I;
    local FoxPawn ForPawn;

    // End:0x4F
    if(PCOwner.MyFoxPawn != none)
    {
        ForPawn = PCOwner.MyFoxPawn;
    }
    // End:0xA2
    else
    {
        // End:0xA2
        if(PCOwner.IsFPSpectating())
        {
            ForPawn = FoxPawn(PCOwner.ViewTarget);
        }
    }
    // End:0xD9
    if((ForPawn == none) || ForPawn.InvManager == none)
    {
        return;
    }
    InvManager = FoxInventoryManager(ForPawn.InvManager);
    OwningWeapon = Mine.WeaponOwner;
    // End:0x1DB
    if(OwningWeapon != none)
    {
        I = 0;
        J0x14C:
        // End:0x1DB [Loop If]
        if(I < 4)
        {
            CurrWeapon = InvManager.GetWeaponFromIndex(I + 2);
            // End:0x1CD
            if((CurrWeapon != none) && CurrWeapon == OwningWeapon)
            {
                as_DestroyGear(I);
            }
            ++ I;
            // [Loop Continue]
            goto J0x14C;
        }
    }
    UpdateGear();
    //return;    
}

function as_UpdateGearItem(int GearIndex, HudGearInfo NewGearInfo)
{
    ActionScriptVoid("updateGearItem");
    //return;    
}

function as_SetGearSelected(int NewSelectedGearIndex)
{
    ActionScriptVoid("gearSelected");
    //return;    
}

function as_DestroyGear(int GearIndex)
{
    ActionScriptVoid("destroyItem");
    //return;    
}
